// generated by Fast Light User Interface Designer (fluid) version 1.0011

#include "demo.h"
#include <pthread.h>
#include "mySerial.h"
#include "myUtils.h"
#include "unistd.h"
#include <Fl/Fl_Image.H>
#define BUFF_SIZE 19200
#define WIDTH 640
#define HEIGHT 480
static pthread_t capture;
static My_Serial com;
static const char* port_name;
static unsigned int baud_rate=0;
static Fl_RGB_Image *m_image;
static int r;  //Resolution value;
static bool bg_avrageflag = false;
static bool D8_filterflag = false;
static bool connected_labelflag = false;
static bool bg_updateflag = false;
static bool contourflag = false;

static unsigned int remoteObjCNT = 0;

typedef enum {
	end_device_sends_line = 0,
	end_device_background_update = 1,
	end_device_sends_detected_lines = 2,
	end_device_sends_only_report = 3,
	end_device_sends_feature_vector = 4,
	end_device_does_image_classification = 5,
	end_device_sends_colored_lines = 6,
} linesensor_mode_t;

linesensor_mode_t ls_mode;

Fl_Double_Window *Demo=(Fl_Double_Window *)0;

Fl_Box *m_box=(Fl_Box *)0;

Fl_Button *m_start=(Fl_Button *)0;

Fl_Button *m_init=(Fl_Button *)0;

Fl_Dial *m_quality=(Fl_Dial *)0;

Fl_Dial *m_time=(Fl_Dial *)0;

static Fl_Value_Output *m_time_v=(Fl_Value_Output *)0;

Fl_Value_Input *m_resolution=(Fl_Value_Input *)0;

Fl_Button *time_send=(Fl_Button *)0;

Fl_Button *res_send=(Fl_Button *)0;

Fl_Button *wnd_send=(Fl_Button *)0;

Fl_Value_Input *m_width=(Fl_Value_Input *)0;

Fl_Value_Input *m_height=(Fl_Value_Input *)0;

Fl_Value_Input *m_x=(Fl_Value_Input *)0;

Fl_Value_Input *m_y=(Fl_Value_Input *)0;

Fl_Button *send_v_h=(Fl_Button *)0;

Fl_Value_Input *hblank=(Fl_Value_Input *)0;

Fl_Value_Input *vblank=(Fl_Value_Input *)0;

Fl_Value_Output *m_image_n=(Fl_Value_Output *)0;

Fl_Value_Output *m_lum=(Fl_Value_Output *)0;

Fl_Value_Output *m_width_res=(Fl_Value_Output *)0;

Fl_Value_Output *m_f_r=(Fl_Value_Output *)0;

Fl_Value_Output *m_height_res=(Fl_Value_Output *)0;

Fl_Value_Output *m_lost=(Fl_Value_Output *)0;

static Fl_Value_Output *m_q_v=(Fl_Value_Output *)0;

Fl_Value_Input *m_com=(Fl_Value_Input *)0;

Fl_Value_Input *m_baud=(Fl_Value_Input *)0;

Fl_Check_Button *m_send=(Fl_Check_Button *)0;

Fl_Button *m_sleep=(Fl_Button *)0;

Fl_Button *m_active=(Fl_Button *)0;

Fl_Input *m_value=(Fl_Input *)0;

Fl_Button *b_reg=(Fl_Button *)0;

Fl_Input *m_reg=(Fl_Input *)0;

Fl_Check_Button *m_bgupdate=(Fl_Check_Button *)0;

Fl_Check_Button *m_contour=(Fl_Check_Button *)0;

Fl_Value_Output *m_object_res=(Fl_Value_Output *)0;

Fl_Check_Button *m_linesensor=(Fl_Check_Button *)0;

Fl_Round_Button *m_unprocessed_lines=(Fl_Round_Button *)0;

Fl_Round_Button *m_detected_lines=(Fl_Round_Button *)0;

Fl_Round_Button *m_object_report=(Fl_Round_Button *)0;

Fl_Round_Button *m_feature_vector=(Fl_Round_Button *)0;

Fl_Round_Button *m_image_classification=(Fl_Round_Button *)0;

Fl_Round_Button *m_colored_lines=(Fl_Round_Button *)0;

Fl_Round_Button *m_background_update=(Fl_Round_Button *)0;

int main(int argc, char **argv) {
  Fl_Double_Window* w;
  Fl::visual(FL_RGB);
  { Fl_Double_Window* o = Demo = new Fl_Double_Window(1155, 728, "Demo for HV7131GP");
    w = o;
    o->box(FL_BORDER_BOX);
    { Fl_Box* o = m_box = new Fl_Box(375, 190, 160, 120);
      o->box(FL_FLAT_BOX);
    }
    { Fl_Button* o = m_start = new Fl_Button(5, 105, 160, 30, "Start comm");
      o->down_box(FL_UP_BOX);
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)start_cb);
    }
    { Fl_Button* o = m_init = new Fl_Button(200, 220, 105, 35, "Init conf");
      o->labeltype(FL_ENGRAVED_LABEL);
      o->callback((Fl_Callback*)init_cb);
      o->deactivate();
    }
    { Fl_Dial* o = m_quality = new Fl_Dial(5, 210, 80, 80, "Quality value");
      o->maximum(2);
      o->step(1);
      o->callback((Fl_Callback*)write_value_cb, (void*)("Quality"));
      o->deactivate();
    }
    { Fl_Dial* o = m_time = new Fl_Dial(5, 322, 80, 78, "Time divisor");
      o->maximum(7);
      o->step(1);
      o->callback((Fl_Callback*)write_value_cb, (void*)("Time"));
      o->deactivate();
    }
    { Fl_Value_Output* o = m_time_v = new Fl_Value_Output(104, 335, 75, 25, "Time divisor");
      o->align(FL_ALIGN_TOP_LEFT);
      o->deactivate();
    }
    { Fl_Value_Input* o = m_resolution = new Fl_Value_Input(105, 420, 80, 25, "Resolution");
      o->maximum(3);
      o->align(FL_ALIGN_TOP);
      o->deactivate();
    }
    { Fl_Button* o = time_send = new Fl_Button(200, 320, 105, 35, "Send time div.");
      o->labeltype(FL_SHADOW_LABEL);
      o->callback((Fl_Callback*)time_cb);
      o->deactivate();
    }
    { Fl_Button* o = res_send = new Fl_Button(200, 410, 105, 35, "Send resolution");
      o->labeltype(FL_SHADOW_LABEL);
      o->callback((Fl_Callback*)res_cb);
      o->deactivate();
    }
    { Fl_Group* o = new Fl_Group(660, 25, 195, 140, "Window");
      o->box(FL_ROUNDED_BOX);
      { Fl_Button* o = wnd_send = new Fl_Button(780, 70, 70, 40, "Send data");
        o->callback((Fl_Callback*)data_cb);
        o->deactivate();
      }
      { Fl_Value_Input* o = m_width = new Fl_Value_Input(705, 35, 70, 25, "Width");
        o->maximum(640);
        o->value(640);
        o->deactivate();
      }
      { Fl_Value_Input* o = m_height = new Fl_Value_Input(705, 65, 70, 25, "Height");
        o->maximum(480);
        o->value(480);
        o->deactivate();
      }
      { Fl_Value_Input* o = m_x = new Fl_Value_Input(705, 95, 70, 25, "X");
        o->minimum(2);
        o->maximum(640);
        o->value(2);
        o->deactivate();
      }
      { Fl_Value_Input* o = m_y = new Fl_Value_Input(705, 130, 70, 25, "Y");
        o->minimum(2);
        o->maximum(480);
        o->value(2);
        o->deactivate();
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(30, 605, 215, 95, "HBLANK vs VBLANK");
      o->box(FL_BORDER_BOX);
      { Fl_Button* o = send_v_h = new Fl_Button(165, 625, 70, 60, "Send");
        o->callback((Fl_Callback*)h_v_cb);
        o->deactivate();
      }
      { Fl_Value_Input* o = hblank = new Fl_Value_Input(95, 625, 65, 25, "HBLANK");
        o->value(208);
        o->deactivate();
      }
      { Fl_Value_Input* o = vblank = new Fl_Value_Input(95, 660, 65, 25, "VBLANK");
        o->value(8);
        o->deactivate();
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(865, 30, 250, 135, "Result");
      o->box(FL_BORDER_BOX);
      { Fl_Value_Output* o = m_image_n = new Fl_Value_Output(925, 35, 70, 20, "Image n");
        o->deactivate();
      }
      { Fl_Value_Output* o = m_lum = new Fl_Value_Output(1030, 35, 80, 25, "Y");
        o->deactivate();
      }
      { Fl_Value_Output* o = m_width_res = new Fl_Value_Output(915, 65, 80, 25, "Width");
        o->deactivate();
      }
      { Fl_Value_Output* o = m_f_r = new Fl_Value_Output(1030, 70, 80, 25, "F.r.");
        o->deactivate();
      }
      { Fl_Value_Output* o = m_height_res = new Fl_Value_Output(915, 100, 80, 25, "Height");
        o->deactivate();
      }
      { Fl_Value_Output* o = m_lost = new Fl_Value_Output(1030, 105, 80, 25, "Lost");
        o->deactivate();
      }
      o->end();
    }
    { Fl_Value_Output* o = m_q_v = new Fl_Value_Output(105, 230, 75, 25, "Qual value");
      o->align(FL_ALIGN_TOP_LEFT);
      o->deactivate();
    }
    { Fl_Value_Input* o = m_com = new Fl_Value_Input(45, 65, 120, 25, "COM:");
      o->maximum(9);
      o->value(3);
    }
    { Fl_Value_Input* o = m_baud = new Fl_Value_Input(5, 30, 160, 25, "Buad rate");
      o->align(FL_ALIGN_TOP_LEFT);
    }
    { Fl_Check_Button* o = m_send = new Fl_Check_Button(120, 265, 160, 30, "Send picture");
      o->down_box(FL_DOWN_BOX);
      o->value(1);
      o->deactivate();
    }
    { Fl_Button* o = m_sleep = new Fl_Button(5, 150, 65, 30, "Sleep");
      o->callback((Fl_Callback*)sleep_cb);
      o->deactivate();
    }
    { Fl_Button* o = m_active = new Fl_Button(100, 150, 65, 30, "Active");
      o->callback((Fl_Callback*)active_cb);
      o->deactivate();
    }
    { Fl_Group* o = new Fl_Group(10, 470, 255, 95, "Set Register");
      o->box(FL_BORDER_BOX);
      { Fl_Input* o = m_value = new Fl_Input(75, 525, 80, 25, "Value");
        o->deactivate();
      }
      { Fl_Button* o = b_reg = new Fl_Button(165, 525, 80, 25, "Set reg");
        o->callback((Fl_Callback*)set_reg_cb);
        o->deactivate();
      }
      { Fl_Input* o = m_reg = new Fl_Input(95, 490, 145, 25, "Register");
        o->deactivate();
      }
      o->end();
    }
    { Fl_Group* o = new Fl_Group(485, 30, 165, 135, "Line Sensor");
      o->box(FL_ROUNDED_BOX);
      { Fl_Check_Button* o = m_bgupdate = new Fl_Check_Button(490, 70, 120, 25, "BG Update");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->callback((Fl_Callback*)bgupdate_cb);
        o->deactivate();
      }
      { Fl_Check_Button* o = m_contour = new Fl_Check_Button(490, 95, 135, 25, "Object Boundary");
        o->down_box(FL_DIAMOND_DOWN_BOX);
        o->callback((Fl_Callback*)contour_cb);
        o->deactivate();
      }
      m_object_res = new Fl_Value_Output(590, 125, 50, 25, "Object Count:");
      o->end();
    }
    { Fl_Check_Button* o = m_linesensor = new Fl_Check_Button(490, 45, 140, 25, "Line Sensors");
      o->down_box(FL_DIAMOND_DOWN_BOX);
      o->callback((Fl_Callback*)linesensor_cb);
      o->deactivate();
    }
    { Fl_Group* o = new Fl_Group(315, 30, 160, 155, "Line Sensor Mode");
      o->box(FL_ROUNDED_BOX);
      { Fl_Round_Button* o = m_unprocessed_lines = new Fl_Round_Button(320, 35, 25, 25, "Unprocessed Lines");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(0));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_detected_lines = new Fl_Round_Button(320, 75, 25, 25, "Detected Lines");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(2));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_object_report = new Fl_Round_Button(320, 95, 25, 25, "Object Report");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(3));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_feature_vector = new Fl_Round_Button(320, 115, 25, 25, "Feature Vector");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(4));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_image_classification = new Fl_Round_Button(320, 135, 25, 25, "Image Classification");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(5));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_colored_lines = new Fl_Round_Button(320, 155, 25, 25, "Colored Lines");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(6));
        o->deactivate();
      }
      { Fl_Round_Button* o = m_background_update = new Fl_Round_Button(320, 55, 25, 25, "background update");
        o->type(102);
        o->down_box(FL_ROUND_DOWN_BOX);
        o->callback((Fl_Callback*)linesensor_mode_cb, (void*)(1));
        o->deactivate();
      }
      o->end();
    }
    o->end();
  }
  m_baud->value(115200);

switch ((int) m_com->value()) {
	case 1:
		port_name = "com1";
		break;

	case 2:
		port_name = "com2";
		break;

	case 3:
		port_name = "com3";
		break;

	case 4:
		port_name = "com4";
		break;

	case 5:
		port_name = "com5";
		break;

	case 6:
		port_name = "com6";
		break;

	case 7:
		port_name = "com7";
		break;

	case 8:
		port_name = "com8";
		break;

	case 9:
		port_name = "com9";
		break;
  }
  baud_rate = (const int) m_baud->value();
  w->show(argc, argv);
  return Fl::run();
}

void write_value_cb(Fl_Widget *, void* userdata) {
  if((const char*) userdata == "Time")
		m_time_v->value(m_time->value());

	/*if((const char*) userdata == "Res")
		m_res_v->value(m_resolution->value());*/

	if((const char*) userdata == "Quality")
		m_q_v->value(m_quality->value());
}

void start_cb(Fl_Widget *, void* userdata) {
  const unsigned char c = 0x31;
	int ret;
	unsigned char answer = 0x00;

	//Set baud-rate
	baud_rate = (const int) m_baud->value();

	if (!my_Serial_init(&com, port_name, baud_rate)) {
		printf("ERROR : Serial init %s \n", port_name);
		exit(EXIT_FAILURE);
	}

	ret = my_Serial_putc(&com, (char)c);

	if (ret < 0 ) {
		printf("ERROR : Serial Put Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) {

		printf("ERROR : Serial Transmit Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	ret = my_Serial_read(&com, (char*)&answer, 1);

	if (ret < 0 ) {

		printf("ERROR : Serial Get Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) {
		printf("ERROR : Serial Receive Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	if (answer != 0x31) {
		printf("ERROR : Bad Serial Answer \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	m_init->activate();
	m_quality->activate();
	m_send->activate();
	m_start->deactivate();
}

void init_cb(Fl_Widget *, void* userdata) {
  int ret;
	unsigned char answer = 0x00;
	unsigned char msg[7];

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x00;
	msg[2] = 0x30 + (int)m_q_v->value();
	msg[3] = 0x2A;
	msg[4] = 0x00;
	msg[5] = 0x30+ (int)m_send->value();
	msg[6] = 0x2A;

	//Setting the serial timeout based on the time divisor
	switch((int)m_q_v->value())
	{
		case 0:
		my_Serial_set_timeout(&com, 1);
		break;

		case 1:
		my_Serial_set_timeout(&com, 3);
		break;

		case 2:
		default:
		my_Serial_set_timeout(&com, 6);
		break;
	}

	ret = my_Serial_write(&com, (char*)&msg, 7);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	ret = my_Serial_read(&com, (char*)&answer, 1);

	if (ret < 0 )
	{
		printf("ERROR : Serial Get Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial Receive Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	if (answer != 0x31)
	{
		printf("ERROR : Bad Serial Answer \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	//Success!! Enable stuff... Disable init button and related stuff
	m_time->activate();
	time_send->activate();
	m_resolution->activate();
	res_send->activate();
	wnd_send->activate();
	m_width->activate();
	m_height->activate();
	m_x->activate();
	m_y->activate();
	m_sleep->activate();
	m_active->activate();
	hblank->activate();
	vblank->activate();
	send_v_h->activate();
	m_reg->activate();
	b_reg->activate();
	m_value->activate();
	m_quality->deactivate();
	m_init->deactivate();
	m_send->deactivate();
	m_linesensor->activate();
	//Maximum size for input
	m_reg->maximum_size(2);
	m_value->maximum_size(2);

	//Resolution value
	r = 4;


	//Start capture
	ret = pthread_create( &capture, NULL, &serial_capture, NULL);
}

void maintain_object_history() {
  //Read MPEG 7 for maintaining image database
//for evwry object maintain
// object type, direction of movement, time, etc... in a database
}

void boundary_based_pattern_recognition() {
  //from the boundary obtained in connected labelled objects
//try to identify object as human, car, bird , etc (pattern recognition)
//using 1d lines
}

void compute_connected_labelling(unsigned char linebuff[][WIDTH] ,int line) {
  static int objectcount = 0;
  static bool objectstart = false;

  bool objectend = true;

  if(line < 2) return;
	//printf("%d ", line);
	for(int i = 1; i < WIDTH - 2 ; i++){
		if(linebuff[line-1][i])//target pixel
			if(linebuff[line-1][i-1] && linebuff[line-1][i+1] &&
					linebuff[line-2][i] &&
				      linebuff[line][i] ){//8 neighbors
				     if(contourflag)
						linebuff[line-1][i] = 1;
					 else
						linebuff[line-1][i] = 150;
					objectstart = true;
					objectend = false;
			}
	}
	if(objectstart && objectend) {
		objectcount++;
		m_object_res->value(objectcount);
		objectstart = false;
	}
}

void contour_cb(Fl_Widget *, void* userdata) {
  if(m_contour->value()){
	  contourflag = true;
	}
	else{
	  contourflag = false;
	}
}

void background_update(unsigned char *line, unsigned char *backgroundline) {
  int THRESHOLD = 25;

  //D8_filterflag = true;
  connected_labelflag = true;

   for(int i=0; i < WIDTH - 1; i++){
	  if(line[i] > backgroundline[i])
		line[i] = line[i] - backgroundline[i];
	  else
		  line[i] = backgroundline[i] - line[i];

		if(line[i] > THRESHOLD)
			line[i] = 255;
		else
			line[i] = 0;
	} {
      }
}

void real_time_background(unsigned char linebuff[][WIDTH] ,int line) {
  static unsigned char backgroundline[WIDTH];

	if(line >= 0 && !bg_avrageflag){

		if(line == 10){
			//memset(backgroundline, 0, WIDTH);
			for(int i=0; i < WIDTH-1; i++){
				for(int j=0; j < 10; j++){
					backgroundline[i] = (backgroundline[i]+linebuff[j][i])/2;
				}
				//backgroundline[i] = backgroundline[i]/(HEIGHT - 1);*/
				//backgroundline[i] = linebuff[line][i];
				//backgroundline[i] = (backgroundline[i]+linebuff[line][i])/2;
			}
			bg_avrageflag=true;
		}
	}
	if(bg_avrageflag && bg_updateflag)
		background_update((unsigned char *)&linebuff[line], backgroundline); {
		//if(D8_filterflag)
			//D_8_neigbor_filter(linebuff, line);
    } {
      }
}

void* serial_capture(void*) {
  unsigned long long count=0;
  static unsigned int line = 0;
  unsigned char buff1[BUFF_SIZE];

unsigned char linebuff[HEIGHT][WIDTH];   //Test
unsigned int msg_idx;
int w,h, ret, y, l;
float fr;

	m_image_n->value(count);

	while (1) {

		count++;

		memset(buff1, 0, BUFF_SIZE);

		ret = my_Serial_read(&com, (char*)&buff1, 15);

		if (ret < 0 ) {
			printf("ERROR : Serial Get Char");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0) {
			printf("ERROR : Serial Receive Timeout");
			pthread_exit(NULL);
		}

		if (buff1[0]==0xAA && buff1[1]==0xBB) {
			msg_idx = 3;
			w =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			w += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;

			h =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			h += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;

			fr =  (((unsigned int)buff1[msg_idx++])  << 24 ) & 0xFF000000;
			fr += (((unsigned int)buff1[msg_idx++])  << 16 ) & 0x00FF0000;
			fr +=  (((unsigned int)buff1[msg_idx++]) << 8  ) & 0x0000FF00;
			fr += (((unsigned int)buff1[msg_idx++])        ) & 0x000000FF;

			fr = (unsigned int) 40000000 / fr;

			l =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			l += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;

			y =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			y += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;
		} else {
			printf("ERROR : Bad Header Received");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		//Write the value in the right field
		m_image_n->value(count);	//Image received
		m_width_res->value(w);		//Width
		m_height_res->value(h); 	//Height
		m_f_r->value(fr);		//Frame rate
		m_lost->value(l);		//Frame lost?
		m_lum->value(y);			//Y mean value

		if(m_send && w && h)
		{

			//Resizs the image box //Test
			if(h == 1){

				m_box->size(w,HEIGHT);

				//memset(linebuff, 0, BUFF_SIZE);

				//if(!(line % w)) line = 0;
				if(!(line % HEIGHT)) line = 0;
				ret = my_Serial_read(&com, (char*)&(linebuff[line]), w*h);
				real_time_background(linebuff ,line);
				//line++;

			}
			else{
				m_box->size(w,h);

				memset(buff1, 0, BUFF_SIZE);

				ret = my_Serial_read(&com, (char*)&buff1, w*h);
			}

			if (ret < 0 ) {

				printf("ERROR : Serial Put Char");
				my_Serial_close(&com);
				exit(EXIT_FAILURE);
			}


			if (ret == 0) {

				printf("ERROR : Serial Transmit Timeout");
				pthread_exit(NULL);
			}

			fflush(stdout);

			if(h==1){
				if(connected_labelflag)
					compute_connected_labelling(linebuff, line);
				if(!image_show(linebuff[0], w, HEIGHT, 1)){
				printf("ERROR : Image Show");
				my_Serial_close(&com);
				exit(EXIT_FAILURE);
				}
				line++;
				if(ls_mode == end_device_sends_only_report){
					remoteObjCNT++;
					m_object_res->value(remoteObjCNT);
				}
			}
			else{
				if(!image_show(buff1, w, h, 1)){
				printf("ERROR : Image Show");
				my_Serial_close(&com);
				exit(EXIT_FAILURE);
				}
			}

			Fl::check();
		}
		else{
			//m_box->redraw();
			Fl::check();
		}
	}
}

bool image_show(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel) {
  if(channel !=1 && channel !=3)
		return false;

	if(m_image) delete m_image;

	m_image = new Fl_RGB_Image(image, w, h,channel);
	m_box->image(m_image);
	m_box->redraw();
	//printf("Perfetto!!");

	return true;
}

void time_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
int ret;

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x54; //T
	msg[2] = 0x2A;
	msg[3] = 0x30;
	msg[4] = 0x30+ m_time_v->value();
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	//Setting the serial timeout based on the time divisor
	switch((int)m_time_v->value())
	{
		case 0:
		my_Serial_set_timeout(&com, 0);
		break;

		case 1:
		my_Serial_set_timeout(&com, 1);
		break;

		case 2:
		my_Serial_set_timeout(&com, 2);
		break;

		case 3:
		my_Serial_set_timeout(&com, 3);
		break;

		case 4:
		my_Serial_set_timeout(&com, 4);
		break;

		case 5:
		my_Serial_set_timeout(&com, 5);
		break;

		case 6:
		my_Serial_set_timeout(&com, 6);
		break;

		case 7:
		default:
		my_Serial_set_timeout(&com, 7);
		break;
	}

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
}

void send_window_data(int height) {
  unsigned char msg[15];
	int ret;
	int size_t;
	size_t = (int)m_width->value() * height / (r * r);

	if(size_t <= 19200){
		//prepare message to send
		msg[0] = 0x2A;
		msg[1] = 0x44; //H
		msg[2] = 0x2A;
		msg[3] = ((int)m_width->value() >> 8) & 0x00FF;
		msg[4] = ((int)m_width->value() 	) & 0x00FF;
		msg[5] = 0x2A;
		msg[6] = ((int)height >> 8) & 0x00FF;
		msg[7] = ((int)height     ) & 0x00FF;
		msg[8] = 0x2A;
		msg[9] = ((int)m_x->value() >> 8) & 0x00FF;
		msg[10] = ((int)m_x->value()    ) & 0x00FF;
		msg[11] = 0x2A;
		msg[12] = ((int)m_y->value() >> 8) & 0x00FF;
		msg[13] = ((int)m_y->value()     ) & 0x00FF;
		msg[14] = 0x2A;

		ret = my_Serial_write(&com, (char*)&msg, 15);

		if (ret < 0 )
		{
			printf("ERROR : Serial io Char \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0)
		{
			printf("ERROR : Serial io Timeout \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
	} else printf("Pkt isn't sent... Buffer bigger than 19200 pixel");
}

void res_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
	int ret;
	long int size_t;

	if(m_resolution->value() > 0)
		size_t = (int)m_width->value() * (int)m_height->value() / (m_resolution->value() * m_resolution->value() * 4);
	else
		size_t = (int)m_width->value() * (int)m_height->value();

	/*if(size_t > 19200){
		//m_width->value(m_width->value()/4);
		m_height->value(m_height->value()/32);
		send_window_data(m_height->value());
		size_t = (int)m_width->value() * (int)m_height->value();
	}*/
	//printf("Resolution values is %d", m_resolution->value());

	if(size_t <= 19200){
		//prepare message to send
		msg[0] = 0x2A;
		msg[1] = 0x52; //R
		msg[2] = 0x2A;
		msg[3] = 0x30;
		msg[4] = 0x30+ m_resolution->value();
		msg[5] = 0x2A;
		msg[6] = 0x2A;
		msg[7] = 0x2A;
		msg[8] = 0x2A;
		msg[9] = 0x2A;
		msg[10] = 0x2A;
		msg[11] = 0x2A;
		msg[12] = 0x2A;
		msg[13] = 0x2A;
		msg[14] = 0x2A;

		ret = my_Serial_write(&com, (char*)&msg, 15);

		if (ret < 0 )
		{
			printf("ERROR : Serial io Char");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0)
		{
			printf("ERROR : Serial io Timeout");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}

		//Set the sent resolution value
		if(m_resolution->value() > 0)
			r = m_resolution->value() * 2;
		else
			r = 1;

	} else printf("Pkt isn't sent... Buffer bigger than 19200 pixel");
}

void bgupdate_cb(Fl_Widget *, void* userdata) {
  if(m_bgupdate->value()){
		bg_updateflag = true;
	}
	else{
		bg_updateflag = false;
	}
}

void linesensor_mode_cb(Fl_Round_Button *, void* userdata) {
  //printf("value of button is %d\n", (int)userdata);
	//Send line Sensor mode command
	unsigned char msg[15];
	int ret;

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x4E;
	msg[2] = 0x2A;
	msg[3] = 0x2A;
	//msg[4] = (char)userdata;

	switch((int)userdata){
		case 0: msg[4] = 0x30;  ls_mode = end_device_sends_line; break;
		case 1: msg[4] = 0x31;  ls_mode = end_device_background_update; break;
		case 2: msg[4] = 0x32;  ls_mode = end_device_sends_detected_lines; break;
		case 3: msg[4] = 0x33;  ls_mode = end_device_sends_only_report; break;
		case 4: msg[4] = 0x34;  ls_mode = end_device_sends_feature_vector; break;
		case 5: msg[4] = 0x35;  ls_mode = end_device_does_image_classification; break;
		case 6: msg[4] = 0x36;  ls_mode = end_device_sends_colored_lines; break;
	}

	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	//printf("Sent \n");
}

void linesensor_cb(Fl_Widget *, void* userdata) {
  int height;
unsigned char msg[15];
  int ret;

	//prepare message to send
	msg[0] = 0x2A;

	msg[2] = 0x2A;
	msg[3] = 0x2A;
	msg[4] = 0x2A;
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	if(m_linesensor->value()){
		bg_avrageflag = false;

		//Send Line Sensor command
		msg[1] = 0x4C; //L

		/* Set height = 28(so that width becomes 640 when res = 0), y = 100 */
		/*height = 28;
		m_height->value(28);
		m_y->value(100);
		send_window_data(height);
		sleep(2);
		m_resolution->value(0);
		res_cb((Fl_Widget *)0,(void *)0);
		sleep(2);
		//height = 1;
		send_window_data(1);*/
		m_bgupdate->activate();
		m_contour->activate();
		m_unprocessed_lines->activate();
		m_background_update->activate();
		m_detected_lines->activate();
		m_object_report->activate();
	}
	else{
		bg_avrageflag = true;

		//Send remove line sensor command
		msg[1] = 0x4D; //M Remove Line Sensor
		/*
		send_window_data(28);
		sleep(2);

		m_resolution->value(2);
		res_cb((Fl_Widget *)0,(void *)0);
		sleep(2);

		height = 480;
		m_height->value(480);
		m_width->value(640);
		m_y->value(2);
		send_window_data(height);*/
		m_bgupdate->deactivate();
		m_contour->deactivate();
		m_unprocessed_lines->deactivate();
		m_background_update->deactivate();
		m_detected_lines->deactivate();
		m_object_report->deactivate();
	}
	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
}

void data_cb(Fl_Widget *, void* userdata) {
  send_window_data((int)m_height->value());
}

void h_v_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
	int ret;

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x48; //H
	msg[2] = 0x2A;
	msg[3] = ((int)hblank->value() >> 8) & 0x00FF;
	msg[4] = ((int)hblank->value() 	   ) & 0x00FF;
	msg[5] = 0x2A;
	msg[6] = ((int)vblank->value() >> 8) & 0x00FF;
	msg[7] = ((int)vblank->value() 	   ) & 0x00FF;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	/*printf("HBLANK: %d, %d, %d: ", (int)hblank->value(), ((int)hblank->value() >> 8) & 0x00FF, ((int)hblank->value()) & 0x00FF);

	printf("VBLANK: %d, %d, %d: ", (int)vblank->value(), ((int)vblank->value() >> 8) & 0x00FF, ((int)vblank->value()) & 0x00FF);*/
}

void set_reg_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
	int ret;
	char r1, r2, v1, v2;

	if((m_reg->index(0) >= 0x30) && (m_reg->index(0) <= 0x39))
		r1 = m_reg->index(0);
	else {
		if((m_reg->index(0) >= 0x41) && (m_reg->index(0) <= 0x46))
			r1 = m_reg->index(0);
		else {
			if((m_reg->index(0) >= 0x61) && (m_reg->index(0) <= 0x66))
				r1 = m_reg->index(0) - 0x20;
			else {
				printf("Register value is not correct");
				return;
			}

		}
	}

	if((m_reg->index(1) >= 0x30) && (m_reg->index(1) <= 0x39))
		r2 = m_reg->index(1);
	else {
		if((m_reg->index(1) >= 0x41) && (m_reg->index(1) <= 0x46))
			r2 = m_reg->index(1);
		else {
			if((m_reg->index(1) >= 0x61) && (m_reg->index(1) <= 0x66))
				r2 = m_reg->index(1) - 0x20;
			else {
				printf("Register value is not correct");
				return;
			}

		}
	}

	if((m_value->index(0) >= 0x30) && (m_value->index(0) <= 0x39))
		v1 = m_value->index(0);
	else {
		if((m_value->index(0) >= 0x41) && (m_value->index(0) <= 0x46))
			v1 = m_value->index(0);
		else {
			if((m_value->index(0) >= 0x61) && (m_value->index(0) <= 0x66))
				v1 = m_value->index(0) - 0x20;
			else {
				printf("Value is not correct");
				return;
			}

		}
	}

	if((m_value->index(1) >= 0x30) && (m_value->index(1) <= 0x39))
		v2 = m_value->index(1);
	else {
		if((m_value->index(1) >= 0x41) && (m_value->index(1) <= 0x46))
			v2 = m_value->index(1);
		else {
			if((m_value->index(1) >= 0x61) && (m_value->index(1) <= 0x66))
				v2 = m_value->index(1) - 0x20;
			else {
				printf("Value is not correct");
				return;
			}

		}
	}

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x31; //1
	msg[2] = 0x2A;
	msg[3] = r1;
	msg[4] = r2;
	msg[5] = 0x2A;
	msg[6] = v1;
	msg[7] = v2;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	/*printf("REG: %d, %d: ", msg[3], msg[4]);

	printf("VALUE: %d, %d: ", msg[6], msg[7]);*/
}

void sleep_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
int ret;

	//Set fastest timeout
	my_Serial_set_timeout(&com, 0);

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x53; //S
	msg[2] = 0x2A;
	msg[3] = 0x2A;
	msg[4] = 0x2A;
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
}

void active_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
int ret;

	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x41; //A
	msg[2] = 0x2A; //C
	msg[3] = 0x2A; //T
	msg[4] = 0x2A;
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;

	ret = my_Serial_write(&com, (char*)&msg, 15);

	if (ret < 0 )
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0)
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	ret = pthread_create( &capture, NULL, &serial_capture, NULL);
	Fl::check();
}

void make_window() {
}
